@extends('layouts.admin.app')

@section('content')

<!-- <!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>viewProduct</title>
    <link href="https://cdn.jsdelivr.net/npm/bootstrap@5.3.3/dist/css/bootstrap.min.css" rel="stylesheet" integrity="sha384-QWTKZyjpPEjISv5WaRU9OFeRpok6YctnYmDr5pNlyT2bRjXh0JMhjY6hW+ALEwIH" crossorigin="anonymous">
    <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.7.1/jquery.min.js" integrity="sha512-v2CJ7UaYy4JwqLDIrZUI/4hqeoQieOmAZNXBeQyjo21dadnwR+8ZaIJVT8EE2iyI61OV8e6M8PP2/4hpQINQ/g==" crossorigin="anonymous" referrerpolicy="no-referrer"></script>
</head> -->
<!-- <body> -->
<main id="main" class="main">
    <div class="container">
        <div class="head" style="display:flex;background:#F3F5F7;">
            <p>Order Id : {{$order->unique_order_id}}</p> 
        </div>
        <p> Purchase Date : {{$order->created_at}}</p>
        <p>
            @if($order->order_delivery_status=='P')
                <div class="alert alert-danger" role="alert" style="width: 20%;text-align:left;">STATUS : PENDING</div>
            @elseif($order->order_delivery_status=='PC')
                <div class="alert alert-secondary" role="alert" style="width: 20%;text-align:left;">STATUS : PROGRESS</div>
            @elseif($order->order_delivery_status=='CL')
                <div class="alert alert-info" role="alert" style="width: 20%;text-align:left;">STATUS : CANCEL</div>
            @elseif($order->order_delivery_status=='H')
                <div class="alert alert-dark" role="alert" style="width: 20%;text-align:left;">STATUS : HOLD</div>
            @elseif($order->order_delivery_status=='D')
                <div class="alert alert-success" role="alert" style="width: 20%;text-align:left;">STATUS : DELIVERED</div>
            @elseif($order->order_delivery_status=='S')
                <div class="alert alert-success" role="alert" style="width: 20%;text-align:left;">STATUS : Shipped</div>
            @endif
        </p>
        <table class="table">
            <thead>
                <tr>
                    <th>Sr No</th>
                    <th>Product Name</th>
                    <th>Send to</th>
                    <th>Price</th>
                    <th>Quantity</th>
                    <th>Total</th>
                </tr>
            </thead>
            <tbody>
                @php $i=0 @endphp
                @php $grandtotal = 0 @endphp
                @foreach($order_details as $order_detail)
                    @if($order->id == $order_detail->order_id)
                        @foreach($product as $products)
                            @if($order_detail->product_id == $products->id)
                                @php $i++; @endphp
                                <tr>
                                    <td>{{$i}}</td>
                                    <td>{{$products->product_name}}</td>
                                    <td>{{$order->delivery_address}}</td>
                                    <td>{{$order_detail->total_price}}</td>
                                    <td>{{$order_detail->qty}}</td>
                                    <td>{{$order_detail->qty * $order_detail->unit_price}}</td>
                                </tr>
                                @php $grandtotal += $order_detail->total_price @endphp
                            @endif
                        @endforeach
                    @endif
                @endforeach
            </tbody>
        </table>
        <div style="text-align:right">
            <p><b>Grand Total :</b>{{$grandtotal}}</p>
        </div>

        @if($disable >= 1)

        @else
        <div class="product_content">
            <h3>Assign Agent</h3>
            <form action="{{url('/viewProduct2')}}/{{$order->id}}" method="post">
                @csrf
                {{--<table class="table" id="AgentAssigndProduct">
                    <thead>
                        <tr>
                            <th>Agent</th>
                            <th>Details</th>
                        </tr>
                    </thead>
                    <tbody>
                        <tr>
                            <td>
                                <select name="agents[0][agent_id]" class="form-control agent-select" data-id="1">
                                    <option value="">Select Agent</option>
                                    @foreach($agents as $agent)
                                        <option value="{{$agent->id}}">{{$agent->name}}</option>
                                    @endforeach
                                </select>
                            </td>
                            <td>
                                <table class="table">
                                    <thead>
                                        <tr>
                                            <th>Product</th>
                                            <th>Price</th>
                                            <th>Action</th>
                                        </tr>
                                    </thead>
                                    <tbody class="AppendPrice">
                                        <tr class="default-row">
                                            <td>
                                                <select name="agents[0][products][]" class="form-control product-select">
                                                    <option value="">Please Select Agent First</option>
                                                </select>
                                            </td>
                                            <td>
                                                <input class="form-control product_price" name="agents[0][product_prices][]" />
                                            </td>
                                            <td>
                                                <button class="btn btn-success btn_addProduct">(+)</button>
                                            </td>
                                        </tr>
                                    </tbody>
                                </table>
                            </td>
                        </tr>
                        <tr>
                            <td></td>
                            <td>
                                <table class="table TotalProductPrice">
                                    <thead>
                                        <tr>
                                            <th>Delivery Type</th>
                                            <th>Price</th>
                                        </tr>
                                    </thead>
                                    <tbody>
                                        <tr>
                                            <td>
                                                <select name="agents[0][delivery_type]" class="form-control deliveryType">
                                                    <option value="" selected>Select Delivery Type</option>
                                                    <option value="s_delivery">STANDARD</option>
                                                    <option value="m_delivery">MIDNIGHT</option>
                                                </select>
                                            </td>
                                            <td>
                                                <input class="form-control delivery_type_price" name="agents[0][delivery_type_price]" />
                                            </td>
                                        </tr>
                                    </tbody>
                                </table>
                            </td>
                        </tr>
                    </tbody>
                </table>--}}
                
                <!-- Appended Products -->
                <div id="appendedProduct"></div>
                
                <!-- Form Footer -->
                <table class="table">
                    <thead>
                        <th></th>
                        <th></th>
                    </thead>
                    <tbody>
                        <tr>
                            <td colspan="2" style="text-align:right;">
                                <button class="btn btn-primary addAgent" type="button">Add Agent</button>
                            </td>
                        </tr>
                    </tbody>
                </table>

                <div id="totalValue" style="margin-bottom:10%;display:none;">
                    <b>TOTAL CHARGES : </b><input class="form-control" name="total" id="total"/>
                </div>
                <input class="form-control" type="hidden" name="OrderID" value="{{$order->unique_order_id}}"/>
                <input class="form-control" type="hidden" name="OrderOriginalID" value="{{$order->id}}"/>

                <div id="button_assign"><button class="btn btn-primary" type="submit" id="btn_assign"  style="display:none;">ASSIGN</button></div>
            </form>

            {{--<form action="{{url('/viewProduct2')}}/{{$order->id}}" method="post">
                    @csrf
                    <table class="table" id="AgentAssigndProduct">
                        <thead>
                            <tr>
                                <th>Agent</th>
                                <th>Details</th>
                            </tr>
                        </thead>
                        <tbody>
                            <tr>
                                <td>
                                    <select name="agent[]" class="form-control agent-select" data-id="1">
                                        <option value="">Select Agent</option>
                                        @foreach($agents as $agent)
                                            <option value="{{$agent->id}}">{{$agent->name}}</option>
                                        @endforeach
                                    </select>
                                </td>
                                <td>
                                    <table class="table">
                                        <thead>
                                            <tr>
                                                <th>Product</th>
                                                <th>Price</th>
                                                <th>Action</th>
                                            </tr>
                                        </thead>
                                        <tbody class="AppendPrice">
                                            <tr class="default-row">
                                                <td>
                                                    <select name="product[]" class="form-control product-select">
                                                        <option value="">Please Select Agent First</option>
                                                    </select>
                                                </td>
                                                <td>
                                                    <input class="form-control product_price" name="product_price[]" />
                                                </td>
                                                <td>
                                                    <button class="btn btn-success btn_addProduct">(+)</button>
                                                </td>
                                            </tr>
                                        </tbody>
                                    </table>
                                </td>
                            </tr>
                            <tr>
                                <td></td>
                                <td>
                                    <table class="table TotalProductPrice" id="">
                                        <thead>
                                            <tr>
                                                <th>Delivery Type</th>
                                                <th>Price</th>
                                            </tr>
                                        </thead>
                                        <tbody>
                                            <tr>
                                                <td>
                                                <select name="delivery_type[]" class="form-control deliveryType">
                                                    <option value="" selected>Select Delivery Type</option>
                                                    <option value="s_delivery">STANDARD</option>
                                                    <option value="m_delivery">MIDNIGHT</option>
                                                </select>
                                                </td>
                                                <td>
                                                    <input class="form-control delivery_type_price" name="delivery_type_price[]" />
                                                </td>
                                                <tr class="AppendTotalPrice"></tr>
                                            </tr>
                                        
                                        </tbody>
                                    </table>
                                </td>
                            </tr>
                        </tbody>
                    </table>
                    <div id="appendedProduct"></div>
                    <table class="table">
                        <thead>
                            <th></th>
                            <th></th>
                        </thead>
                        <tbody>
                            <tr>
                                <td colspan="2" style="text-align:right;">
                                    <button class="btn btn-primary addAgent" type="submit">Add Agent</button>
                                </td>
                            </tr>
                        </tbody>
                    </table>
                    <div id="totalValue" style="margin-bottom:10%;display:none;"><b>TOTAL CHARGES : </b><input class="form-control" name="total" id="total"/></div>
                    <div id="button_assign"><button class="btn btn-primary" type="submit" id="btn_assign">ASSIGN</button></div>
                </form>
                <form action="{{ url('/viewProduct2') }}/{{$order->id}}" method="post">
                @csrf
                <div id="AgentAssigndProductContainer">
                    <!-- Agent rows will be dynamically added here -->
                </div>

                <div id="totalValue" style="margin-bottom:10%; display:none;">
                    <b>TOTAL CHARGES: </b>
                    <input class="form-control" name="total" id="total" readonly/>
                </div>

                <div id="button_assign">
                    <button class="btn btn-primary" type="submit" id="btn_assign" >ASSIGN</button>
                </div>
            </form>--}}

        @endif
        
        @if($disable == 0)
        @else
        <h2 style="margin-top: 5%;">Processed Order</h2>
        @php
            $groupedData = [];
            foreach ($assinged as $assignedItem) {
                foreach ($assigned_agent_product_map as $assigned_agent_product_maps) {
                    if ($assignedItem->id == $assigned_agent_product_maps->agent_assinged_id) {
                        $agent = $agents->firstWhere('id', $assignedItem->agent_id);
                        $productItem = $product->firstWhere('id', $assigned_agent_product_maps->product_id);
                        $productMapedItem = $agent_product_list->firstWhere('id', $assigned_agent_product_maps->product_id);
                        if ($productItem && $agent) {
                            $agentId = $assignedItem->agent_id;

                            if (!isset($groupedData[$agentId])) {
                                $groupedData[$agentId] = [
                                    'products' => [],
                                    'mapped_details' => [],
                                    'OrderID' => $assignedItem->id,
                                    'agent_order_id' => $assignedItem->agent_order_id,
                                    'totalPrice' => $assignedItem->totalPrice,
                                    'status' => $assignedItem->status,
                                    'agent_name' => $agent->name,
                                    'extra' => $assignedItem->extra,
                                    'Deliver_charge' => $assignedItem->Deliver_charge,
                                    'reason' => $assignedItem->reason,
                                    'track_no' => $assignedItem->track_no,
                                    'isConfirmCl' => $assignedItem->isConfirmCl
                                ];
                            }

                            $groupedData[$agentId]['products'][] = $productItem->product_name;
                            $groupedData[$agentId]['mapped_details'][] = $productMapedItem->item;
                        }
                    }
                }
            }

        @endphp
                    <table class="table">
                        <thead>
                            <tr>
                                <th>Sr No</th>
                                <th>Order Id</th>
                                <th>Product Name (Mapped Details)</th>
                                <th>Assigned Agent Name</th>
                                <th>Delivery Price</th>
                                <th>Extra</th>
                                <th>Delivery Charge</th>
                                <th>Reason</th>
                                <th>Track No</th>
                                <th>Status</th>
                                <th></th>
                            </tr>
                        </thead>
                        <tbody>
                            @php $i = 1; @endphp
                            @php 
                            $Delivery_Price = 0;	
                            $Extra = 0;
                            $Delivery = 0; 
                            $total = 0;
                             @endphp
                            @foreach($groupedData as $data)
                                <tr>
                                    <td>{{ $i++ }}</td>
                                    <td>{{ $data['agent_order_id'] }}</td>
                                    <td>
                                        {!! implode('<br>', $data['mapped_details']) !!}
                                    </td>
                                    <td>{{ $data['agent_name'] }}</td>
                                    <td>{{ $data['totalPrice'] }}</td>
                                    <td>{{ $data['extra'] }}</td>
                                    <td>{{ $data['Deliver_charge'] }}</td>
                                    <td>{{ $data['reason'] }}</td>
                                    <td>{{ $data['track_no'] }}</td>
                                    <td>
                                        @if($data['status'] == 'P')
                                            <div class="alert alert-danger" role="alert" style="width: 100%; text-align: center;">PENDING</div>
                                        @elseif($data['status'] == 'PC')
                                            <div class="alert alert-secondary" role="alert" style="width: 100%; text-align: center;">PROGRESS</div>
                                        @elseif($data['status'] == 'CL')
                                            <div class="alert alert-info" role="alert" style="width: 100%; text-align: center;">CANCEL</div>
                                        @elseif($data['status'] == 'H')
                                            <div class="alert alert-dark" role="alert" style="width: 100%; text-align: center;">HOLD</div>
                                        @elseif($data['status'] == 'S')
                                            <div class="alert alert-success" role="alert" style="width: 100%; text-align: center;">Shipped</div>
                                        @elseif($data['status'] == 'D')
                                            <div class="alert alert-success" role="alert" style="width: 100%; text-align: center;">DELIVERED</div>
                                        @endif
                                    </td>
                                    <td>
                                        @if($data['isConfirmCl'] == 0 && $data['status'] == "CL")
                                            <button class="btn btn-primary btn_cancel" id="btn_cancel" ds-value="{{ $data['OrderID'] }}">Add Agent</button>
                                        @endif
                                    </td>
                            @endforeach
                        </tbody>
                    </table>
                    @foreach($groupedData as $amount)
                        @if($amount['isConfirmCl'] != 1 && $amount['status'] != "CL")
                            <!-- {{$amount['totalPrice']}} = {{$amount['extra']}} = {{$amount['Deliver_charge']}} -->
                             <!-- <br> -->
                            @php    
                                $total +=$amount['totalPrice'] + $amount['extra'] + $amount['Deliver_charge'];
                            @endphp
                         @endif
                    @endforeach
                   

                    <!-- <table class="table reassign" style="display:none;">
                        <thead>
                            <th>Order Id</th>
                            <th>Please Select Vendor</th>
                            <th>Total</th>
                            <th></th>
                        </thead>
                        <tbody id="assign_data">
                            <tr>
                                <td>
                                    <input class="form-control" type="hidden" name="OrderId" id="OrderId" disabled>
                                    <input class="form-control" type="" name="agent_order_id" id="agent_order_id" disabled>
                                </td>
                                <td>
                                    <select name="reassignAggent" id="reassignAggent" class="form-control reassignAggent">
                                        <option value="" selected>Please Select Agent</option>
                                        @foreach($agents as $agent)
                                            <option value="{{$agent->id}}">{{$agent->name}}</option>
                                        @endforeach
                                    </select>
                                </td>
                                <td>
                                    <input class="form-control" name="re_price" id="re_price" disabled>
                                </td>
                                <td><button class="btn btn-primary .btn_reasiign" id="btnReAssign">ASSIGN</button></td>
                            </tr>
                        </tbody>
                    </table> -->
                    <div id="ReassignProduct"></div>


                    <h3>Customer Email</h3>
                       @php 
                            $count = 0; 
                            $buttonEnable = count($agentasGroupBy) + 1;
                            $buttonCount = 1; 
                        @endphp

                        @foreach($agentasGroupBy as $assign)
                            @if($assign->status != 'P')
                                @php 
                                    $count++; 
                                    $buttonCount++; 
                                @endphp                      
                            @endif
                        @endforeach

                        <table class="table">
                            <thead>
                                <tr>
                                    <th></th>
                                    <th></th>
                                    <th></th>
                                </tr>
                            </thead>
                            <tbody>
                                <tr>
                                    @if($count > 0)
                                        <td>
                                            <select name="mail_status" id="mail_status" class="form-control mail_status">
                                            <option value="">Select Mail Process</option>
                                                @if($order->order_delivery_status == 'P')
                                                    <option value="PC">Processed</option>
                                                    <option value="S">Shipped</option>
                                                    <option value="D">Delivered</option>
                                                @elseif($order->order_delivery_status == 'PC')
                                                    <option value="S">Shipped</option>
                                                    <option value="D">Delivered</option>
                                                @elseif($order->order_delivery_status == 'S')
                                                    <option value="D">Delivered</option>
                                                @endif

                                            </select>
                                        </td>
                                    @endif
                                    <td>
                              
                                    </td>
                                    @if($buttonCount == $buttonEnable)
                                        <td>
                                        <button class="btn btn-primary" id="btn_mail_send" @if($order->order_delivery_status == 'D') Style="display:none;" @else @endif>SEND</button>
                                        </td>
                                    @endif
                                </tr>
                            </tbody>
                        </table>
                        @php $grandTotal = 0 @endphp
                        @if($order->order_delivery_status == 'D')
                        @php 
                        $grandTotal = $Delivery_Price+$Extra+$Delivery+$total;@endphp
                        <p><b>Paid To AgentL :  {{$total}}</b></p>
                        @endif
                        @if($order->order_delivery_status == 'PC')
                            <table class="table" style="display:none;" id="AssignIds">
                                <thead>
                                    <tr>
                                        <th></th>
                                    </tr>
                                </thead>
                                <tbody>
                                @foreach($agentasGroupBy as $assignItems)
                                    @if($assignItems->status == "CL")
                                    @else
                                    <tr>
                                        <td>
                                            <input class="form-control" name="OrderId" value="{{$assignItems->agent_order_id}}" disabled/>
                                        </td>
                                        <td>
                                            <input class="form-control" name="track_no" value="{{$assignItems->track_no}}" />
                                        </td>
                                    </tr>
                                    @endif
                                @endforeach
                                </tbody>
                            </table>
                        @endif
  
    @endif
    </div>
    </main>
<!-- </body>
</html> -->


<!-- <script src="https://cdn.jsdelivr.net/npm/bootstrap@5.3.3/dist/js/bootstrap.bundle.min.js" integrity="sha384-YvpcrYf0tY3lHB60NNkmXc5s9fDVZLESaAA55NDzOxhy9GkcIdslK1eN7N6jIeHz" crossorigin="anonymous"></script> -->
<script>
    $(document).on('click', '.addAgent', function(e) {
        e.preventDefault();
        
        var agentIndex = $('#appendedProduct .AgentAssigndProduct').length;

        var agentHTML = `
            <table class="table AgentAssigndProduct">
                <thead>
                    <tr>
                        <th>Agent</th>
                        <th>Details</th>
                    </tr>
                </thead>
                <tbody>
                    <tr>
                        <td>
                            <select name="agents[${agentIndex}][agent_id]" class="form-control agent-select" data-id="${agentIndex}">
                                <option value="">Select Agent</option>
                                @foreach($agents as $agent)
                                    <option value="{{$agent->id}}">{{$agent->name}}</option>
                                @endforeach
                            </select>
                        </td>
                        <td>
                            <table class="table">
                                <thead>
                                    <tr>
                                        <th>Product</th>
                                        <th>Price</th>
                                        <th>QTY</th>
                                        <th>Action</th>
                                    </tr>
                                </thead>
                                <tbody class="AppendPrice">
                                    <tr class="default-row">
                                        <td>
                                            <select name="agents[${agentIndex}][0][products][]" class="form-control product-select" data-agent-index="${agentIndex}" data-product-index="0">
                                                <option value="">Please Select Agent First</option>
                                            </select>
                                        </td>
                                        <td>
                                            <input class="form-control product_price" name="agents[${agentIndex}][0][product_prices][]" />
                                        </td>
                                        <td>
                                            <input class="form-control product_qty" name="agents[${agentIndex}][0][product_qty][]" value="1"/>
                                        </td>
                                        <td>
                                            <button class="btn btn-success btn_addProduct" data-agent-index="${agentIndex}">(+)</button>
                                        </td>
                                    </tr>
                                </tbody>
                            </table>
                        </td>
                    </tr>
                    <tr>
                        <td></td>
                        <td>
                            <table class="table TotalProductPrice">
                                <thead>
                                    <tr>
                                        <th>Delivery Type</th>
                                        <th>Price</th>
                                        <th>Total Price</th>
                                    </tr>
                                </thead>
                                <tbody>
                                    <tr>
                                        <td>
                                            <select name="agents[${agentIndex}][delivery_type]" class="form-control deliveryType" data-agent-index="${agentIndex}">
                                                <option value="" selected>Select Delivery Type</option>
                                                <option value="s_delivery">STANDARD</option>
                                                <option value="m_delivery">MIDNIGHT</option>
                                            </select>
                                        </td>
                                        <td>
                                            <input class="form-control delivery_type_price" name="agents[${agentIndex}][delivery_type_price]" />
                                        </td>
                                         <td>
                                            <input class="form-control totalprice" name="agents[${agentIndex}][total_price]" />
                                        </td>
                                    </tr>
                                </tbody>
                            </table>
                        </td>
                    </tr>
                </tbody>
            </table>
        `;

        $('#appendedProduct').append(agentHTML);
        $('#btn_assign').css('display', 'block');

    });

    $(document).on('change', '.agent-select', function() {
        var agentIndex = $(this).data('id');
        var agent_id = $(this).val();
        
        var $selectProduct = $(`select[name="agents[${agentIndex}][0][products][]"]`);
        $selectProduct.html('<option value="">Loading...</option>'); 

        if (agent_id) {
            $.ajax({
                url: "{{ url('/ProductByAgent') }}", 
                type: 'GET',
                data: { agent_id: agent_id },
                success: function(response) {
                    var products = response;
                    $selectProduct.html('<option value="">Select Product</option>'); 
                    products.forEach(function(product) {
                        $selectProduct.append(`<option value="${product.id}">${product.item}</option>`);
                    });
                },
                error: function(error) {
                    console.log("Error fetching products:", error);
                }
            });
        } else {
            $selectProduct.html('<option value="">Select Agent First</option>');
        }
    });

    $(document).on('change', '.product-select', function() {
        var agentIndex = $(this).data('agent-index'); 
        var productIndex = $(this).data('product-index'); 
        var product_id = $(this).val(); 
        
        var $totalPrice = $(`input[name="agents[${agentIndex}][${productIndex}][product_prices][]"]`);

        if (product_id) {
            $.ajax({
                url: "{{ url('/GetPriceByProduct') }}",  
                type: 'GET',
                data: { product_id: product_id },
                success: function(response) {
                    $totalPrice.val(response.price);
                },
                error: function(error) {
                    console.log("Error fetching price:", error);
                }
            });
        }
    });

    $(document).on('click', '.btn_addProduct', function(e) {
        e.preventDefault();

        var $thisButton = $(this); 
        var agentIndex = $thisButton.data('agent-index'); 
        var productIndex = $thisButton.closest('.AppendPrice').find('tr').length;
        var agent_id = $(`[name="agents[${agentIndex}][agent_id]"]`).val();

        if (agent_id) {
            $.ajax({
                url: "{{ url('/ProductByAgent') }}", 
                type: 'GET',
                data: { agent_id: agent_id },
                success: function(response) {
                    var productRow = `
                        <tr>
                            <td>
                                <select name="agents[${agentIndex}][${productIndex}][products][]" class="form-control product-select" data-agent-index="${agentIndex}" data-product-index="${productIndex}">
                                    <option value="">Select Product</option>`;
                    
                    response.forEach(function(product) {
                        productRow += `<option value="${product.id}">${product.item}</option>`;
                    });

                    productRow += `
                                </select>
                            </td>
                            <td>
                                <input class="form-control" name="agents[${agentIndex}][${productIndex}][product_prices][]" />
                            </td>
                            <td>
                                <input class="form-control product_qty" name="agents[${agentIndex}][${productIndex}][product_qty][]" value="1"/>
                            </td>
                            <td>
                                <button class="btn btn-danger btn_removeProduct">(-)</button>
                            </td>
                        </tr>`;

                    $thisButton.closest('.AppendPrice').append(productRow); 
                },
                error: function(error) {
                    console.log("Error fetching products:", error);
                }
            });
        } else {
            alert("Please select an agent first.");
        }
    });

    $(document).on('click', '.btn_removeProduct', function(e) {
        e.preventDefault();
        $(this).closest('tr').remove(); 
    });

    $(document).on('change', '.deliveryType', function() {
        var $this = $(this);
        var agentIndex = $this.data('agent-index'); 
        var Dtype = $this.val(); 
        var agent_id = $(`[name="agents[${agentIndex}][agent_id]"]`).val();
        var $totalPrice = $(`input[name="agents[${agentIndex}][delivery_type_price]"]`); 
        var $total = $(`input[name="agents[${agentIndex}][total_price]"]`);  

        if (!agent_id) {
            alert('Please select an agent first.');
            return;
        }

        var productPrices = [];
        var productqty = [];
        $(`input[name^="agents[${agentIndex}]["][name$="product_prices][]"]`).each(function() {
            productPrices.push(parseFloat($(this).val()) || 0); 
        });

        $(`input[name^="agents[${agentIndex}]["][name$="product_qty][]"]`).each(function() {
            productqty.push(parseFloat($(this).val()) || 0); 
        });
        // console.log(productqty);
        var deliveryTypePrice = parseFloat($totalPrice.val()) || 0;

        $.ajax({
            url: "{{ url('/GetDeliveryType') }}",
            type: "GET",
            data: {
                Dtype: Dtype,
                agent_id: agent_id,
                productPrices: productPrices,
                productqty:productqty,
            },
            success: function(response) {
                // console.log(response);
                // console.log();
                var totalProductPrice = productPrices.reduce((sum, price) => sum + price, 0);
                var deliveryCharge = 0;
                // console.log(totalProductPrice);
                if (Dtype === 's_delivery') {
                    deliveryCharge = response.agent_delivery_charge.s_delivery;
                } else if (Dtype === 'm_delivery') {
                    deliveryCharge = response.agent_delivery_charge.m_delivery;
                }

                $totalPrice.val(deliveryCharge);
                var total = response.total + deliveryCharge;
                $total.val(total);
            },
            error: function(error) {
                console.log("Error fetching delivery type:", error);
            }
        });
    });
</script>





<!-- <script>
    $(document).ready(function() {
        $(document).on('change', '.agent-select', function() {
            var agent_id = $(this).val();
            var $selectProduct = $(this).closest('tr').find('.product-select');
            // console.log(agent_id);
            $selectProduct.html('<option value="">Loading...</option>');
            
            if (agent_id) {
                $.ajax({
                    url: "{{ url('/ProductByAgent') }}", 
                    type: 'GET',
                    data: { agent_id: agent_id },
                    success: function(response) {
                        var products = response;
                        $selectProduct.html('<option value="">Select Product</option>');
                        products.forEach(function(product) {
                            $selectProduct.append('<option value="' + product.id + '">' + product.item + '</option>');
                        });
                    },
                    error: function(error) {
                        console.log("Error fetching products:", error);
                    }
                });
            } else {
                $selectProduct.html('<option value="">Select Agent First</option>');
            }
        });

        $(document).on('change', '.product-select', function() {
            var product_id = $(this).val();
            var $totalPrice = $(this).closest('tr').find('input[name="product_price[]"]');

            if (product_id) {
                $.ajax({
                    url: "{{ url('/GetPriceByProduct') }}",  
                    type: 'GET',
                    data: { product_id: product_id },
                    success: function(response) {
                        $totalPrice.val(response.price);
                    },
                    error: function(error) {
                        console.log("Error fetching price:", error);
                    }
                });
            }
        });

    $(document).on('click', '.addAgent', function(e) {
        e.preventDefault();
        var clone = $('#AgentAssigndProduct').clone().removeAttr('id');
        clone.find('input, select').val('');
        clone.find('.AppendPrice').children('tr').not(':first').remove();
        clone.find('.btn_addProduct').removeClass('btn_addProduct').addClass('btn_addProductDynamic');
        $('#appendedProduct').append(clone);
    });

        $(document).on('click', '.removeAgent', function(e) {
            e.preventDefault();
            $(this).closest('table').remove();
        });

    $(document).on('click', '.btn_addProduct, .btn_addProductDynamic', function(e) {
        e.preventDefault();
        var agent_id = $('.agent-select').val();
        if (!agent_id) {
            alert("Please choose an agent first.");
            return;
        }

        $.ajax({
            url: "{{ url('/ProductByAgent') }}", 
            type: 'GET',
            data: { agent_id: agent_id },
            success: function(response) {
                // console.log(response);

                var productRow = `
                    <tr>
                        <td>
                            <select name="product[]" class="form-control product-select">
                                <option value="">Select Product</option>`;
                
                response.forEach(function(product) {
                    productRow += `<option value="${product.id}">${product.item}</option>`;
                });

                productRow += `
                            </select>
                        </td>
                        <td>
                            <input class="form-control" name="product_price[]" />
                        </td>
                        <td>
                            <button class="btn btn-danger removeProduct">(-)</button>
                        </td>
                    </tr>`;

                $(e.target).closest('.AppendPrice').append(productRow);
            },
            error: function(error) {
                console.log("Error fetching products:", error);
            }
        });


    });
    $(document).on('click', '.removeProduct', function(e) {
            e.preventDefault();
            $(this).closest('tr').remove();
        });
    });
    $(document).ready(function() {
        function CalculateTotalPrice() {
            var productPrices = [];
            var deliveryTypePrices = [];
            var product = 0;
            var delivery = 0;
            var price = 0;
            var AppndproductPrices = [];
            var AppnddeliveryTypePrices = [];
            var Appndproduct = 0;
            var Appndproductdelivery = 0;

            var uniqueProductPrices = new Set();
            var uniqueDeliveryTypePrices = new Set();
            var uniqueAppndProductPrices = new Set();
            var uniqueAppndDeliveryTypePrices = new Set();

            $('#AgentAssigndProduct tbody tr').each(function(index, row) {
                var productPrice = $(row).find('input[name="product_price[]"]').val();
                var deliveryTypePrice = $(row).find('input[name="delivery_type_price[]"]').val();

                if (!isNaN(parseFloat(productPrice))) {
                    uniqueProductPrices.add(parseFloat(productPrice));
                }
                if (!isNaN(parseFloat(deliveryTypePrice))) {
                    uniqueDeliveryTypePrices.add(parseFloat(deliveryTypePrice));
                }
            });

            $('#appendedProduct tbody tr').each(function(index, row) {
                var AppndproductPrice = $(row).find('input[name="product_price[]"]').val();
                var AppnddeliveryTypePrice = $(row).find('input[name="delivery_type_price[]"]').val();

                if (!isNaN(parseFloat(AppndproductPrice))) {
                    uniqueAppndProductPrices.add(parseFloat(AppndproductPrice));
                }
                if (!isNaN(parseFloat(AppnddeliveryTypePrice))) {
                    uniqueAppndDeliveryTypePrices.add(parseFloat(AppnddeliveryTypePrice));
                }
            });

            uniqueProductPrices.forEach(function(price) {
                product += price;
            });

            uniqueAppndProductPrices.forEach(function(price) {
                Appndproduct += price;
            });

            uniqueDeliveryTypePrices.forEach(function(price) {
                delivery += price;
            });

            uniqueAppndDeliveryTypePrices.forEach(function(price) {
                Appndproductdelivery += price;
            });

            price = product + delivery + Appndproduct + Appndproductdelivery;

            $('#totalValue').css('display', 'block');
            $('#total').val(price);

        }

        $(document).on('change', '.deliveryType', function() {
            var Dtype = $(this).val();
            var agent_id = $('.agent-select').val();
            var $totalPrice = $(this).closest('tr').find('input[name="delivery_type_price[]"]');
            if (!agent_id) {
                alert('Please select an agent first.');
                return;
            }
            $.ajax({
                url: "{{ url('/GetDeliveryType') }}",
                type: "GET",
                data: {
                    Dtype: Dtype,
                    agent_id: agent_id,
                },
                success: function(response) {
                    if(response.Dtype == 's_delivery'){
                        $totalPrice.val(response.agent_delivery_charge.s_delivery);
                    }else{
                        $totalPrice.val(response.agent_delivery_charge.m_delivery);
                    }

                    CalculateTotalPrice();
                },
                error: function(error) {
                    console.log("Error fetching delivery type:", error);
                }
            });
        });
        
    });
</script> -->

<script>
    $(document).ready(function(){
    //     $('.AssignAgent').change(function(){
    //        var agentCourrierId = $('#agentCourrier').val(); 
    //        var values = [];

    //        $(".assignProductCourrier:checked").each(function() {
    //            values.push($(this).val());
    //        });

    //        $.ajax({
    //            url: "{{ url('/getPrice') }}", 
    //            type: 'GET', 
    //            data: {
    //                agentCourrierId: agentCourrierId, 
    //                values: values,
    //            },
    //            success: function(response) {
    //                 console.log(response);
    //                $('#courrier_price').val(response);
    //            },
    //             error: function(error) {
    //                console.log(error);
    //            }
    //        });
    //    });

        // $('#agentParcel').change(function(){
        //     var agentCourrierId = $('#agentParcel').val(); 
        //     var values = [];
        //     $(".assignProductParcel:checked").each(function() {
        //         values.push($(this).val());
        //     });
        //     // console.log(values);
        //     $.ajax({
        //         url: "{{ url('/getPrice') }}", 
        //         type: 'GET', 
        //         data: {
        //             agentCourrierId: agentCourrierId, 
        //             values: values,
        //         },
        //         success: function(response) {
        //             // console.log(response);
        //             $('#parcel_price').val(response);
        //             // $('#button_assign').append(`
        //             //     <button class="btn btn-primary" type="submit" id="btn_assign">ASSIGN</button>
        //             // `);
        //         },
        //         error: function(error) {
        //             console.log(error);
        //         }
        //     });
        // });
        
            // $('#button_assign').on('click', function () {
            //     var AgentOrderID = @json($order->unique_order_id);
            //     var OrderID = @json($order->id);
            //     let formDataCourrier = {
            //         assignProducts: [],
            //         agent: $('#agentCourrier').val(),
            //         courrier_price: $('#courrier_price').val()
            //     };
            //     $('.assignProductCourrier:checked').each(function () {
            //         formDataCourrier.assignProducts.push($(this).val());
            //     });

            //     let formDataParcel = {
            //         assignProducts: [],
            //         agent: $('#agentParcel').val(),
            //         parcel_price: $('#parcel_price').val()
            //     };
            //     $('.assignProductParcel:checked').each(function () {
            //         formDataParcel.assignProducts.push($(this).val());
            //     });

            //     // console.log(formDataCourrier);
            //     // console.log(formDataParcel);

            //     $.ajax({
            //         url: "{{url('/MultyassignAgent')}}",
            //         type: 'GET',
            //         data: {
            //             AgentOrderID:AgentOrderID,
            //             OrderID:OrderID,
            //             courrierData: formDataCourrier,
            //             parcelData: formDataParcel
            //         },
            //         success: function (response) {
            //             //  console.log(response);
            //             location.reload();
            //         },
            //         error:function(error){
            //             console.log(error);
            //         },
            //     });
            // });
            $('.btn_cancel').click(function(){
                var orderId = $(this).attr('ds-value');
                var reassignAggent = $('#reassignAggent').val();
                $('.reassign').css('display', 'block');
                $.ajax({
                    url:"{{url('/getOrderID')}}",
                    type:'get',
                    data:{
                        orderId:orderId,
                        reassignAggent:reassignAggent,
                    },
                    success:function(response){
                    var agentIndex = $('#ReassignProduct .AgentAssigndProduct').length;

                    var agentHTML = `
                    <form action="{{url('/ReAssignProduct')}}" method="post">
                    @csrf
                         <input class="form-control" type="hidden" name="OrderId" id="OrderId" disabled value=${response.id}>
                        <b>ORDER ID :</b><input class="form-control" type="" name="agent_order_id" id="agent_order_id" value=${response.agent_order_id}>
                        <table class="table AgentAssigndProduct">
                            
                            <thead>
                                <tr>
                                    <th>Agent</th>
                                    <th>Details</th>
                                </tr>
                            </thead>
                            <tbody>
                                <tr>
                                    <td>
                                        <select name="agents[${agentIndex}][agent_id]" class="form-control agent-select" data-id="${agentIndex}">
                                            <option value="">Select Agent</option>
                                            @foreach($agents as $agent)
                                                <option value="{{$agent->id}}">{{$agent->name}}</option>
                                            @endforeach
                                        </select>
                                    </td>
                                    <td>
                                        <table class="table">
                                            <thead>
                                                <tr>
                                                    <th>Product</th>
                                                    <th>Price</th>
                                                    <th>QTY</th>
                                                    <th>Action</th>
                                                </tr>
                                            </thead>
                                            <tbody class="AppendPrice">
                                                <tr class="default-row">
                                                    <td>
                                                        <select name="agents[${agentIndex}][0][products][]" class="form-control product-select" data-agent-index="${agentIndex}" data-product-index="0">
                                                            <option value="">Please Select Agent First</option>
                                                        </select>
                                                    </td>
                                                    <td>
                                                        <input class="form-control product_price" name="agents[${agentIndex}][0][product_prices][]" />
                                                    </td>
                                                    <td>
                                                        <input class="form-control product_qty" name="agents[${agentIndex}][0][product_qty][]" value="1"/>
                                                    </td>
                                                    <td>
                                                        <button class="btn btn-success btn_addProduct" data-agent-index="${agentIndex}">(+)</button>
                                                    </td>
                                                </tr>
                                            </tbody>
                                        </table>
                                    </td>
                                </tr>
                                <tr>
                                    <td></td>
                                    <td>
                                        <table class="table TotalProductPrice">
                                            <thead>
                                                <tr>
                                                    <th>Delivery Type</th>
                                                    <th>Price</th>
                                                    <th>Total Price</th>
                                                </tr>
                                            </thead>
                                            <tbody>
                                                <tr>
                                                    <td>
                                                        <select name="agents[${agentIndex}][delivery_type]" class="form-control deliveryType" data-agent-index="${agentIndex}">
                                                            <option value="" selected>Select Delivery Type</option>
                                                            <option value="s_delivery">STANDARD</option>
                                                            <option value="m_delivery">MIDNIGHT</option>
                                                        </select>
                                                    </td>
                                                    <td>
                                                        <input class="form-control delivery_type_price" name="agents[${agentIndex}][delivery_type_price]" />
                                                    </td>
                                                    <td>
                                                        <input class="form-control totalprice" name="agents[${agentIndex}][total_price]" />
                                                    </td>
                                                </tr>
                                            </tbody>
                                        </table>
                                    </td>
                                </tr>
                            </tbody>
                        </table>
                       
                        <div style="text-align:right;"><button class="btn btn-primary .btn_reasiign" type="submit" id="btnReAssign">ASSIGN</button></div>
                        </form>
                    `;

                    $('#ReassignProduct').append(agentHTML);
                        // $('#OrderId').val(response.id);
                        // $('#agent_order_id').val(response.agent_order_id);
                        // console.log(response);
                    },
                    error:function(error){
                        console.log(error);
                    }
                });
            });


            $('#reassignAggent').change(function(){
                var OrderId = $('#OrderId').val();
                var reassignAggent = $('#reassignAggent').val();
                $.ajax({
                    url:"{{url('/getReAssignPrice')}}",
                    type:"GET",
                    data:{
                        OrderId:OrderId,
                        reassignAggent:reassignAggent,
                    },
                    success:function(response){
                        // console.log(response);
                        $('#re_price').val(response);
                    },
                    error:function(error){
                        console.log(error);
                    },
                }); 
            });
            $('#btnReAssign').click(function(){
                var OrderId = $('#OrderId').val();
                var reassignAggent = $('#reassignAggent').val();
                var re_price = $('#re_price').val();
                $.ajax({
                    url:"{{url('/Reassign')}}",
                    type:"GET",
                    data:{
                        OrderId:OrderId,
                        reassignAggent:reassignAggent,
                        re_price:re_price,
                    },
                    success:function(response){
                        // console.log(response);
                        location.reload();
                    },
                    error:function(error){
                        console.log(error);
                    },
                }); 
            });

            $('#btn_mail_send').click(function(){
                var mail_status = $('#mail_status').val();
                var OrderID = @json($order->id);
                $.ajax({
                    url:"{{url('/mailStatus')}}",
                    type:'GET',
                    data:{
                        mail_status:mail_status,
                        OrderID:OrderID,
                    },
                    success:function(response){
                        // console.log(response);
                        location.reload();
                    },
                    error:function(error){  
                        console.log(error);
                    },
                });
            });
            $('.mail_status').change(function(){
                var mail_status = $('#mail_status').val();
                console.log(mail_status);
                if(mail_status == 'S'){
                    $('#AssignIds').css('display', 'block');
                }else{
                    $('#AssignIds').css('display', 'none');
                }
            });

    });
</script>

@endsection
