@extends('layouts.admin.app')

@section('content')

<main id="main" class="main">
    <div class="container" style="margin-top:5%;">
        <form action="{{url('/admin/ProfitReport')}}" method="post">
            @csrf
            <div class="card">
                <div class="card-body">
                    <p><b>START DATE :</b><input type="date" class="form-control" name="start-date" required/></p>
                    <p><b>END DATE :</b><input type="date" class="form-control" name="end-date" required/></p>
                    <p><b>PROFIT TYPE :</b>
                    <select name="profitType" id="profitType" class="form-control" required>
                        <option value="" selected>Select The Profit Type</option>
                        <option value="20">20% - 30%</option>
                        <option value="31">31% - 40%</option>
                        <option value="41">41% - 50%</option>
                        <option value="51">51% - 60%</option>
                        <option value="60">ABOVE 60%</option>
                        <option value="ALL">ALL</option>
                    </select></p>
                    <button class="btn btn-primary" type="submit">Search</button>
                </div>
            </div>
        </form>
    </div>
</main>

<script src="https://cdn.jsdelivr.net/npm/bootstrap@5.3.3/dist/js/bootstrap.bundle.min.js" integrity="sha384-YvpcrYf0tY3lHB60NNkmXc5s9fDVZLESaAA55NDzOxhy9GkcIdslK1eN7N6jIeHz" crossorigin="anonymous"></script>

<script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.7.1/jquery.min.js" integrity="sha512-v2CJ7UaYy4JwqLDIrZUI/4hqeoQieOmAZNXBeQyjo21dadnwR+8ZaIJVT8EE2iyI61OV8e6M8PP2/4hpQINQ/g==" crossorigin="anonymous" referrerpolicy="no-referrer"></script>

@endsection