@extends('layouts.admin.app')

@section('content')

    <main id="main" class="main">
        <div class="container">
            <form action="{{url('/admin/productAssign')}}" method="post">
                    @csrf
                    <table class="table" styla="margin-top:10%;">
                        <thead>
                            <tr>
                                <th>From Date</th>
                                <th>To Date</th>
                                <th>Select the Status</th>
                                <th></th>
                            </tr>
                        </thead>
                        <tbody>
                            <tr>
                                <td><input type="date" name="fromDate" id="FromDate" class="form-control" required /></td>
                                <td><input type="date" name="toDate" id="toDate" class="form-control" required /></td>
                                <td>
                                    <select name="status" id="status" class="form-control" required>
                                        <option value="" selected>SELECT STATUS</option>
                                        <option value="P">PENDING</option>
                                        <option value="PC">PROCESSED</option>
                                        <option value="S">SHIPPED</option>
                                        <option value="D">DELIVERED</option>
                                        <option value="H">HOLD</option>
                                        <option value="CL">CANCELED</option>
                                    </select>
                                </td>
                                <td><button class="btn btn-primary" type="submit">Search</button></td>
                            </tr>
                        </tbody>
                    </table>
            </form>
            <table class="table">
                @if($agent_assigned->isEmpty())
                    No Data Found
                @else
                    <thead>
                        <tr>
                            <th scope="col">Sr No</th>
                            <th scope="col">Assign Order Id</th>
                            <th scope="col">Order id</th>
                            <th scope="col">Agent Name</th>
                            <th scope="col">Product Name</th>
                            <th scope="col">Delivery Date</th>
                            <th scope="col">status</th>
                            {{--<th scope="col">Agent Status</th>--}}
                            <th scope="col">view</th>
                        </tr>
                    </thead>
                    <tbody>
                        @php $i = 0; @endphp
                        @foreach($agent_assigned as $agent_assigneds)
                            @php $i++; @endphp
                            <tr>
                                <th scope="row">{{$i}}</th>
                                <td>{{$agent_assigneds->agent_order_id}}</td>
                                <td>
                                    @php
                                        $orderId = null;
                                    @endphp
                                    @foreach($assined as $assineds)
                                        @foreach($orders as $order)
                                            @if($assineds->OID == $order->id)
                                                {{$order->unique_order_id}}
                                                @php
                                                    $orderId = $order->id;
                                                    break 2;
                                                @endphp
                                            @endif
                                        @endforeach
                                    @endforeach
                                </td>
                                <td>
                                    @foreach($agents as $agent)
                                        @if($agent_assigneds->agent_id == $agent->id)
                                            {{$agent->name}}
                                            @break
                                        @endif
                                    @endforeach
                                </td>
                                <td>
                                    @php
                                        $printedProducts = [];
                                    @endphp
                                    @foreach($product_maped as $product_mapeds)
                                        @if($product_mapeds->agent_assinged_id == $agent_assigneds->id)
                                            @foreach($agent_product_list as $product)
                                                @if($product->id == $product_mapeds->product_id && !in_array($product->id, $printedProducts))
                                                    {{ $product->item }}<br>
                                                    @php
                                                        $printedProducts[] = $product->id; 
                                                    @endphp
                                                @endif
                                            @endforeach
                                        @endif
                                    @endforeach
                                </td>
                                <td>
                                    @php
                                        $founddetails = false;
                                    @endphp
                                    @foreach($order_details as $order_detail)
                                        @if($order_detail->order_id == $agent_assigneds->OID)
                                            {{$order_detail->delivery_date}}
                                            @php
                                                $founddetails = true;
                                                break;
                                            @endphp
                                        @endif
                                    @endforeach
                                </td>
                                <td>
                                    @if($agent_assigneds->status=='P')
                                        <div class="alert alert-danger" role="alert" style="width: 80%;text-align: center;">PENDING</div>
                                        @elseif($agent_assigneds->status=='PC')
                                        <div class="alert alert-secondary" role="alert" style="width: 80%;text-align: center;">PROGRESS</div>
                                        @elseif($agent_assigneds->status=='CL')
                                        <div class="alert alert-info" role="alert" style="width: 80%;text-align: center;">CANCEL</div>
                                        @elseif($agent_assigneds->status=='H')
                                        <div class="alert alert-dark" role="alert" style="width: 80%;text-align: center;">HOLD</div>
                                        @elseif($agent_assigneds->status=='D')
                                        <div class="alert alert-success" role="alert" style="width: 80%;text-align: center;">DELIVERED</div>
                                        @elseif($agent_assigneds->status=='S')
                                        <div class="alert alert-success" role="alert" style="width: 80%;text-align: center;">Shipped</div>
                                    @endif
                                </td>
                                {{--<td>
                                    @if($agent_assigneds->status == "PC" ||$agent_assigneds->status == "CL" ||$agent_assigneds->status == "D" ||$agent_assigneds->status == "S")
                                    <div class="alert alert-primary" role="alert">
                                        Agent Assigned
                                    </div>
                                    @else
                                    <div class="alert alert-danger" role="alert">
                                        Agent Not Assigned Yet
                                    </div>
                                    @endif
                                </td>--}}
                                <td><a href="{{url('/admin/dashboard')}}/{{$agent_assigneds->agent_order_id}}/{{$agent_assigneds->agent_id}}" class="btn btn-primary">VIEW</a></td>
                            </tr>
                        @endforeach
                    </tbody>
                @endif    
            </table>
            <a class="btn btn-danger" href="{{url('/admin/main')}}">Back</a>
        </div>
    </main>

<script src="https://cdn.jsdelivr.net/npm/bootstrap@5.3.3/dist/js/bootstrap.bundle.min.js" integrity="sha384-YvpcrYf0tY3lHB60NNkmXc5s9fDVZLESaAA55NDzOxhy9GkcIdslK1eN7N6jIeHz" crossorigin="anonymous"></script>

<script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.7.1/jquery.min.js" integrity="sha512-v2CJ7UaYy4JwqLDIrZUI/4hqeoQieOmAZNXBeQyjo21dadnwR+8ZaIJVT8EE2iyI61OV8e6M8PP2/4hpQINQ/g==" crossorigin="anonymous" referrerpolicy="no-referrer"></script>

@endsection